unit frmFo;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
  auHTTP, ShellAPI;

type
  TfrmMain = class(TForm)
    auHTTP: TauHTTP;
    pLog1: TPanel;
    Memo1: TMemo;
    pUzenet1: TPanel;
    lUzenet: TLabel;
    pBtnBar1: TPanel;
    Bfrissit: TButton;
    Bhivoprg: TButton;
    Bkilep: TButton;
    procedure BfrissitClick(Sender: TObject);
    procedure BhivoprgClick(Sender: TObject);
    procedure BkilepClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure auHTTPAnyError(Sender: TObject);
  private
    hiba: boolean;
    updfile, hivoprg, hivoexe, hivoverzio, NemLathatoAzUzenet, AtadadandoParameter: string;

    procedure letolt(url, celfile: string);
    function verzio_osszehasonlitas(const aHelyi, aSzerver: string): Boolean;
  public
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses
  Math;

procedure tfrmMain.letolt(url, celfile: string);
begin
  auhttp.URL := url;
  auhttp.OutputFileName := celfile;
  auhttp.Read(true);
end;

procedure TfrmMain.BfrissitClick(Sender: TObject);
var
  verziofile: textfile;
  szverzio, forras, cel: string;
  iohiba: integer;
begin
  bfrissit.Enabled := false;
  bhivoprg.Enabled := false;
  bkilep.Enabled := false;
  hiba := false;

  memo1.Lines.Clear;
  memo1.Lines.Add('Verzi ellenrzse...');
  letolt('http://dafiles.dimenzio-kft.hu/update/' + updfile, updfile);

  if (not hiba) then
  begin

    assignfile(verziofile, updfile);
    reset(verziofile);
    readln(verziofile); //a frisst prg. verzi sora
    readln(verziofile, szverzio); //a dimsql verzi sora
    memo1.Lines.Add(hivoprg + ' verzi a szerveren: ' + stringreplace(szverzio, ',', '.', [rfReplaceAll]));
    memo1.Lines.Add(hivoprg + ' helyi verzi: ' + stringreplace(hivoverzio, ',', '.', [rfReplaceAll]));

    szverzio := stringreplace(szverzio, '.', ',', [rfReplaceAll]);
    hivoverzio := stringreplace(hivoverzio, '.', ',', [rfReplaceAll]);
    if hivoverzio = '' then
      hivoverzio := '0';

//    if (Verzio_Osszehasonlitas(hivoverzio, szverzio) = 2) then
//    if (CompareValue(StrToFloat(hivoverzio), StrToFloat(szverzio)) < 0) then
    if (verzio_osszehasonlitas(hivoverzio, szverzio)) then
    begin
      // file-ok letltse "t" kiegsztssel a kiterjesztsben
      while (not hiba) and (not eof(verziofile)) do
      begin
        readln(verziofile, forras);
        case forras[1] of
          '@':
            begin // j knyvtr ltrehozsa
              forras := copy(forras, 2, length(forras) - 1);
              memo1.Lines.Add(forras + ' knyvtr ltrehozsa...');
              {$i-} mkdir(forras); {$i+}
              iohiba := ioresult; // csak hogy kirljn az ioresult
              memo1.Lines.Add('Rendben');
            end;
          '':
            begin // knyvtr trlse
              forras := copy(forras, 2, length(forras) - 1);
              memo1.Lines.Add(forras + ' knyvtr trlse...');
              {$i-} rmdir(forras); {$i+}
              iohiba := ioresult; // csak hogy kirljn az ioresult
              memo1.Lines.Add('Rendben');
            end;
          '':
            begin // file trlse
              forras := copy(forras, 2, length(forras) - 1);
              memo1.Lines.Add(forras + ' file trlse...');
              {$i-} deletefile(forras); {$i+}
              iohiba := ioresult; // csak hogy kirljn az ioresult
              memo1.Lines.Add('Rendben');
            end;
        else // file letltse
          begin
            readln(verziofile, cel);
            if cel[1] = '*' then // ez a futtathat exe, arra ez esetre, ha a hv programot tneveztk
              cel := hivoexe;
            memo1.Lines.Add(cel + ' file letltse...');
            letolt(forras, cel + 't');
            memo1.Lines.Add('Rendben');
          end;
        end;
      end;
      closefile(verziofile);

      if (not hiba) then
      begin
        // sikeres letlts utn az aktulis file-ok mentse az \update knyvtrba
        memo1.Lines.Add('Biztonsgi ments ksztse az \update knyvtrba...');
        {$i-} mkdir('update'); {$i+}
        iohiba := ioresult; // csak hogy kirljn az ioresult
        reset(verziofile);
        readln(verziofile);
        readln(verziofile);
        while not eof(verziofile) do
        begin
          readln(verziofile, forras);
          case forras[1] of
            '@':
              begin // j knyvtr ltrehozsa
                forras := copy(forras, 2, length(forras) - 1);
                {$i-} mkdir('update\' + forras); {$i+}
                iohiba := ioresult; // csak hogy kirljn az ioresult
              end;
            '':
              begin // knyvtr trlse
                forras := copy(forras, 2, length(forras) - 1);
                {$i-} rmdir('update\' + forras); {$i+}
                iohiba := ioresult; // csak hogy kirljn az ioresult
              end;
            '':
              begin // file trlse
                forras := copy(forras, 2, length(forras) - 1);
                {$i-} deletefile('update\' + forras); {$i+}
                iohiba := ioresult; // csak hogy kirljn az ioresult
              end;
          else // file letltse
            begin
              readln(verziofile, cel);
              if cel[1] = '*' then // ez a futtathat exe, arra ez esetre, ha a hv programot tneveztk
                cel := hivoexe;
              copyfile(pansichar(cel), pansichar('update\' + cel), false);
            end;
          end;
        end;
        closefile(verziofile);

        // ha sikerlt a letlts, a "t"-s file-ok msolsa az eredeti nevkre
        memo1.Lines.Add('Letlttt file-ok tnevezse...');
        reset(verziofile);
        readln(verziofile);
        readln(verziofile);
        while not eof(verziofile) do
        begin
          readln(verziofile, forras);
          if not (forras[1] in ['@', '', '']) then
          begin
            readln(verziofile, cel);
            if cel[1] = '*' then
              cel := hivoexe;
            copyfile(pansichar(cel + 't'), pansichar(cel), false);
          end;
        end;
        closefile(verziofile);
      end;

      // a "t"-s file-ok trlse
      memo1.Lines.Add('tmeneti file-ok trlse...');
      reset(verziofile);
      readln(verziofile);
      readln(verziofile);
      while not eof(verziofile) do
      begin
        readln(verziofile, forras);
        if not (forras[1] in ['@', '', '']) then
        begin
          readln(verziofile, cel);
          if cel[1] = '*' then
            cel := hivoexe;
          deletefile(pansichar(cel + 't'));
        end;
      end;
      closefile(verziofile);
    end
    else
    begin
      memo1.Lines.Add('A szerveren nincs a helyinl jabb verzi.');
      showmessage('A szerveren nincs a helyinl jabb verzi.');
      closefile(verziofile);
    end;
    Memo1.Lines.Add(' ');
  end;

  if (not hiba) then
  begin
    memo1.Lines.Add('A frissts befejezdtt.');
    memo1.Lines.Add(hivoprg + ' indtsa gomb: kilp s elindtja a ' + hivoprg + ' programot.');
    memo1.Lines.Add('Kilp gomb: kilp frissts nlkl.');
  end
  else
  begin
    memo1.Lines.Add('A frissts nem sikerlt.');
    showmessage('A frissts nem sikerlt.');
  end;

  bfrissit.Enabled := true;
  bhivoprg.Enabled := true;
  bkilep.Enabled := true;
end;

procedure TfrmMain.BhivoprgClick(Sender: TObject);
begin
  //AtadadandoParameter = ha kapott 6. paramterknt akkor azt tovbb tudja adni pl. digitaudit>>Dokufrissites
  if AtadadandoParameter <> '' then
    ShellExecute(0, nil, PAnsiChar(hivoexe), PAnsiChar(AtadadandoParameter), nil, SW_SHOWNORMAL)
  else
    ShellExecute(0, nil, PAnsiChar(hivoexe), nil, nil, SW_SHOWNORMAL);

  application.Terminate;
end;

procedure TfrmMain.BkilepClick(Sender: TObject);
begin
  application.Terminate;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  if paramcount >= 3 then
  begin
    updfile := paramstr(1);
    hivoprg := paramstr(2);
    hivoexe := paramstr(3);
    hivoverzio := paramstr(4);
    NemLathatoAzUzenet := paramstr(5);
    AtadadandoParameter := paramstr(6);

    if (NemLathatoAzUzenet <> '') then
    begin
      pUzenet1.Visible := False;
    end;

    application.Title := hivoprg + ' frissts';
    Caption := hivoprg + ' frissts';
    Bhivoprg.Caption := hivoprg + ' indtsa';
    Memo1.Lines.Add('Frisst gomb: indtja a frisstst.');
    Memo1.Lines.Add(hivoprg + ' indtsa gomb: kilp s elindtja a ' + hivoprg + ' programot.');
    Memo1.Lines.Add('Kilp gomb: kilp frissts nlkl.');
  end
  else
  begin
    showmessage('Nincs elg paramter a program futtatshoz.');
    application.Terminate;
  end;
end;

procedure TfrmMain.auHTTPAnyError(Sender: TObject);
begin
  Hiba := True;
  Application.MessageBox(PChar('Hiba a fjl letltse kzben!'), PChar('Hiba'), MB_OK + MB_ICONSTOP);
end;

function TfrmMain.verzio_osszehasonlitas(const aHelyi, aSzerver: string): Boolean;
var
	HelyiVerzio: TStringList;
	SzerverVerzio: TStringList;
  i: Integer;

begin
  Result := False;

  HelyiVerzio := TStringList.Create;
  SzerverVerzio := TStringList.Create;
  try
		HelyiVerzio.Delimiter := '.';
		SzerverVerzio.Delimiter := '.';

    HelyiVerzio.DelimitedText := StringReplace(aHelyi, ',', '.', [rfReplaceAll]);
    SzerverVerzio.DelimitedText := StringReplace(aSzerver, ',', '.', [rfReplaceAll]);

  	for i:=0 to HelyiVerzio.Count - 1 do
    begin
  		if (StrToInt(SzerverVerzio[i]) > StrToInt(HelyiVerzio[i])) then
      begin
      	Result := True;
        Break;
      end;
    end;
  finally
    SzerverVerzio.Free;
    HelyiVerzio.Free;
  end;
end;

end.


